from flow.mutable_model import MutableModel
import argparse
import os

parser = argparse.ArgumentParser(description='Deploy best trained model to backend')

parser.add_argument(
    '--dry', 
    required=False, 
    action='store_true', 
    help="Shows uuid of model to be deployed without deploy")

args = parser.parse_args()

mmdl = MutableModel()
best_uuid = mmdl.deployable_trained_uuid()

if __name__ == '__main__':

    if args.dry:
        if best_uuid is None:
            best_uuid = 'None'
        print("Trained model to be deployed: {}".format(str(best_uuid)))
    else:
        mmdl.redeploy(best_uuid)
        if best_uuid is not None:
            cmd = 'poetry version ' + mmdl.get_version()
            os.system(cmd)
