from flask import Flask, jsonify, request, render_template
import pandas as pd

from flow.mutable_model import MutableModel

app = Flask(__name__)

mmodel = MutableModel()

@app.route('/')
def index():
    stats_df = pd.DataFrame(mmodel.get_trained_stats())
    stats_df.sort_values(by=['version'], ascending=False, inplace=True)

    return render_template(
        "index.html",
        version=mmodel.get_version(),
        model_desc=str(mmodel.backend['model']),
        stats=stats_df
        )

