# Define Performance
from helloml.performance import Performance

# Architecture Version
def version():
    return(
        '0.1'
    )

# Example using mean_squared_error
from sklearn.metrics import mean_squared_error
def backend_performance():
    return(
        Performance(
            metric_function=mean_squared_error,
            abreviation='mse',
            min_value=0.0,
            max_value=float('Inf'),
            is_bigger_better=False,
            version_length=4
        )
    )

# Define Backend Model
from sklearn.linear_model import LinearRegression

def backend_model():
    mdl = LinearRegression()

    return(mdl)


# Design Methods for Interface
# -- register interface methods
def interface_methods():
    ret = {}
    # -- PREDICT
    def predict(backend_mdl, *args, **kwargs):
        return(
            backend_mdl.predict(*args, **kwargs)
        )
    ret['predict'] = predict

    return(ret)
