from helloml.bookkeeper import BookKeeper
from helloml.architecture import version, interface_methods


class Model(object):
    def __init__(self):

        self.bookkeeper = BookKeeper()
        self.backend = self.bookkeeper.get_backend()
        self.version = version()

        self.methods = interface_methods()

    def execute(self, method_name, *args, **kwargs):
        return(
            self.methods[method_name](
                self.backend['model'],
                *args, **kwargs
            )
        )

    def get_current_performance(self):
        return(
            self.backend['performance'].current_value
        )

    def get_version(self):
        """
        Version = <Arch/Software>.PerformanceVersion+Abreviation
            e.g = x.y.0.0000+mse
        """
        ver = self.version + '.'
        ver += self.backend['performance'].score_to_version()

        return(ver)

 